import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.display.Shader;
import flash.display.ShaderJob;
import flash.filters.ShaderFilter;
import flash.media.Camera;
import flash.utils.getTimer;

[Embed(source="net/onthewings/filters/scale2x.pbj", mimeType="application/octet-stream")]
public var scale2x:Class;
public var scale2xShader:Shader;
public var scale2xShader2:Shader;
public var scale2xShaderJob:ShaderJob;

[Embed(source="net/onthewings/filters/scale3x.pbj", mimeType="application/octet-stream")]
public var scale3x:Class;
public var scale3xShader:Shader;
public var scale3xShaderJob:ShaderJob;

[Embed(source="Posterizer.pbj", mimeType="application/octet-stream")]
public var Posterizer:Class;
public var PosterizerShader:Shader;
public var PosterizerShaderFilter:ShaderFilter;

public var resultBM2x:Bitmap;
public var resultBM3x:Bitmap;

public var smallBD:BitmapData = new BitmapData(160,120);
public var mediumBD:BitmapData = new BitmapData(320,240);

public var resultBD2x:BitmapData = new BitmapData(640,480);
public var resultBD3x:BitmapData = new BitmapData(480,360);

public function init():void {
	var cam:Camera = Camera.getCamera();
	cam.setMode(160,120,60);
	cameraFPS.text = cam.fps.toString();
	cameraResolution.text = cam.width + ' * ' + cam.height;
	videoDisplay.attachCamera(cam);
	
	scale2xShader = new Shader(new scale2x());
	scale2xShader.data.w.value = [160];
	scale2xShader.data.h.value = [120];
	scale2xShader.data.src.input = smallBD;

	scale2xShader2 = new Shader(new scale2x());
	scale2xShader2.data.w.value = [320];
	scale2xShader2.data.h.value = [240];
	scale2xShader2.data.src.input = mediumBD;
	
	scale3xShader = new Shader(new scale3x());
	scale3xShader.data.w.value = [160];
	scale3xShader.data.h.value = [120];
	scale3xShader.data.src.input = smallBD;
	
	PosterizerShader = new Shader(new Posterizer());
	PosterizerShaderFilter = new ShaderFilter(PosterizerShader);
	videoDisplay.filters = [PosterizerShaderFilter];
	
	resultBM2x = new Bitmap(resultBD2x);
	resultBM3x = new Bitmap(resultBD3x);
	processedvideo.rawChildren.addChild(resultBM2x);
	processedvideo.rawChildren.addChild(resultBM3x);
	
	resultBM3x.visible = false;
}

public function changeUseMethodType(methodIndex:int):void {
	var is2x:Boolean = methodIndex == 0 || methodIndex == 2;
	resultBM2x.visible = is2x;
	resultBM3x.visible = !is2x;
}

public function processvideoFrame():void {
	var time:Number; 
	smallBD.draw(videoDisplay);
	resultBD2x.lock();
	resultBD3x.lock();
	if (useMethodType.selectedIndex == 0){
		time = getTimer();
		scale2xShaderJob = new ShaderJob(scale2xShader,mediumBD);
		scale2xShaderJob.start(true);
		scale2xShaderJob = new ShaderJob(scale2xShader2,resultBD2x);
		scale2xShaderJob.start(true);
		processingTime.text = (getTimer() - time) + "ms";
	} else if (useMethodType.selectedIndex == 1){
		time = getTimer();
		scale3xShaderJob = new ShaderJob(scale3xShader,resultBD3x);
		scale3xShaderJob.start(true);
		processingTime.text = (getTimer() - time) + "ms";
	} else if (useMethodType.selectedIndex == 2){
		time = getTimer();
		resultBD2x.draw(ScaleX.scale2x(ScaleX.scale2x(smallBD)));
		processingTime.text = (getTimer() - time) + "ms";
	} else {
		time = getTimer();
		resultBD3x.draw(ScaleX.scale3x(smallBD));
		processingTime.text = (getTimer() - time) + "ms";
	}
	resultBD2x.unlock();
	resultBD3x.unlock();
}